#include <stdio.h>
#include <stdlib.h>
#include "bcpcilib.h"

char	version[] = "Version 1.00";


/*********************************************************************/
/*	main							                                 */
/*********************************************************************/

void main()

{
	int		a, b, i;
	char	buffer[360];	/* allow buffer space for 5 boards
							   72 bytes per board */

	unsigned int	bufpointer;
	unsigned short	vendid, devid;
	unsigned char 	bus, dev, func, irq;
	unsigned long	bar0, bar1, bar2, bar3, bar4, bar5, sn;



/***
 ***	Demonstrate Library Function 'BctBoardCount()
 ***/
	printf("	BCT PCI Board Search - %s\n\n\n", version); 
	printf("\nSearching for BCT PCI boards\n\n");

    a = BctBoardCount();
    

	if (a>255) {
		printf("PCI Error condition exists - Unable to return Board Count\n\n");
        switch (a>>8) {
        	case 1:		printf("No PCI BIOS present\n"); break;
			default:	printf("Program Fault - Unknown error returned \n"); break;       	
		}
		exit(0);
	}
	else {
		printf("Number of BCT PCI Boards detected = %x\n\n\n\n", a);
		
	}



/***
 ***	Demonstrate Library Function 'BctBoardInfo()
 ***/

	if (!a) {
		printf("No BCT PCI boards were detected\n\n");
		exit(0);
	}
		
	b = BctBoardInfo(&buffer);
	bufpointer = 0;

	for (i=1; i<=a; i++) {
		sscanf(buffer+bufpointer, "%04x %4x %2x %2x %2x %2x %8lx %8lx %8lx %8lx %8lx %8lx %8lx",
		 &vendid, &devid, &bus, &dev, &func, &irq, &bar0, &bar1, &bar2, &bar3, &bar4, &bar5, &sn);

		/* each board has 72 bytes (72 ascii characters) of information in the buffer */
		
		bufpointer = 72*i;    	/* set buffer pointer to next board's info */
	
		printf("\nVid:  Did:  Bus Dev Fnc Irq     S/N        \n");
		printf("%04x  %04x   %02x  %02x  %02x  %02x  %08lx   Bar0 %08lx\n",
			vendid, devid, bus, dev, func, irq, sn, bar0);
		
		printf("                                        Bar1 %08lx\n", bar1);
		printf("                                        Bar2 %08lx\n", bar2);
		printf("                                        Bar3 %08lx\n", bar3);
		printf("                                        Bar4 %08lx\n", bar4);
		printf("                                        Bar5 %08lx\n", bar5);

	}
}
