#include <stdio.h>
#include "pcilib.h"
#include "bcpcilib.h"



BC_WORD BctBoardCount()
{
	int Bus, Dev, Fn, tmp, status;
	unsigned long	vendor;
	unsigned char	hw_mech;						// hardware mechanism
	unsigned short	interface_lvl_version;	        // interface level version
	unsigned char	last_bus_number;				// last PCI bus no.
	unsigned char	count=0;						// count of BCT boards 
	
// Determine if PCI BIOS is present and find last pci bus number

    if(!pci_bios_present(&hw_mech,&interface_lvl_version,&last_bus_number)){
    	status = BCT_NO_PCI_BIOS_PRESENT;	// PCI BIOS not present 
		return(status);
    }


	for(Bus=0; Bus<=last_bus_number; Bus++) {
		for(Dev=0; Dev<32; Dev++) {
//			for(Fn=0; Fn<8; Fn++) {
			for(Fn=0; Fn<1; Fn++) {
				tmp = (Fn & 0x7) | ((Dev & 0x1f)<<3);

				vendor = pci_read_cs32((unsigned char)Bus, (unsigned char)tmp, 0);
				vendor = vendor & 0xffff;
				if (vendor == BCT_VENDOR_ID)
					count++;

			}
		}
	}
	return(count);
}





int BctBoardInfo(char *buffer)
{

	int		buflen=0;
	int		Bus, Dev, Fn, tmp;

	unsigned long	Status;
	unsigned char	i;
	unsigned long	j;
	unsigned char	hw_mech;						// hardware mechanism
	unsigned short	interface_lvl_version;	        // interface level version
	unsigned char	last_bus_number;				// last PCI bus no.
	
// Determine if PCI BIOS is present and find last pci bus number

    if(!pci_bios_present(&hw_mech,&interface_lvl_version,&last_bus_number)){
		return(0);
    }


	for(Bus=0; Bus<=last_bus_number; Bus++) {
		for(Dev=0; Dev<32; Dev++) {
//			for(Fn=0; Fn<8; Fn++) {
			for(Fn=0; Fn<1; Fn++) {
				tmp = (Fn & 0x7) | ((Dev & 0x1f)<<3);

				Status = pci_read_cs32((unsigned char)Bus, (unsigned char)tmp, 0);
				if ((Status & 0xffff) == BCT_VENDOR_ID) {
					buflen += sprintf(buffer+buflen,"%04x%04x%02x%02x%02x",
					       (int)(Status&0xffff), (int)((Status>>16)&0xffff), Bus, Dev, Fn);
					Status = pci_read_cs32((unsigned char)Bus, (unsigned char)tmp, 15<<2);
					buflen += sprintf(buffer+buflen,"%02x", Status&0xff);
					
					for(i=0; i<6; i++) {
						Status = pci_read_cs32((unsigned char)Bus, (unsigned char)tmp, (i+4)<<2);
							if(Status & 1) 
								buflen += sprintf(buffer+buflen,"%08x", Status & 0xfffffffe);
							
							else 
								buflen += sprintf(buffer+buflen,"%08x", Status & 0xfffffff0);
							
					}
					Status = pci_read_cs32((unsigned char)Bus, (unsigned char)tmp, 0x2C);
					//exchange lower 16 bit word for higher 16 bit word
					j=Status>>16;
					Status=Status<<16|j;
					buflen += sprintf (buffer+buflen,"%08lx", Status); 
				}
			}
		}
	}
	return(buflen);
}
