#include "bcdefn.h"

/* PCI BIOS function codes */
#define PCI_FUNCTION_ID             0xB1
#define PCI_BIOS_RESIDENT           0x01
#define PCI_FIND_PCI_DEVICE         0x02
#define PCI_FIND_PCI_CLASS_CODE     0x03
#define PCI_GENERATE_SPECIAL_CYCLE  0x06
#define PCI_READ_CS_BYTE            0x08
#define PCI_READ_CS_WORD            0x09
#define PCI_READ_CS_DWORD           0x0A
#define PCI_WRITE_CS_BYTE           0x0B
#define PCI_WRITE_CS_WORD           0x0C
#define PCI_WRITE_CS_DWORD          0x0D

/* PCI BIOS return codes */
#define PCI_SUCCESSFUL           0x00
#define PCI_NOT_SUCCESSFUL       0x01
#define PCI_FUNC_NOT_SUPPORTED   0x81
#define PCI_BAD_VENDOR_ID        0x83
#define PCI_DEVICE_NOT_FOUND     0x86
#define PCI_BAD_REGISTER_NUMBER  0x87

/* PCI configuration space registers */
#define PCI_CS_VENDOR_ID         0x00
#define PCI_CS_DEVICE_ID         0x02
#define PCI_CS_COMMAND           0x04
#define PCI_CS_STATUS            0x06
#define PCI_CS_REVISION_ID       0x08
#define PCI_CS_CLASS_CODE        0x09
#define PCI_CS_CACHE_LINE_SIZE   0x0C
#define PCI_CS_MASTER_LATENCY    0x0D
#define PCI_CS_HEADER_TYPE       0x0E
#define PCI_CS_BIST              0x0F
#define PCI_CS_BAR0				0x10
#define PCI_CS_BAR1				0x14
#define PCI_CS_BAR2				0x18
#define PCI_CS_BAR3				0x1C
#define PCI_CS_BAR4				0x20
#define PCI_CS_BAR5				0x24
#define PCI_CS_EXPANSION_ROM     0x30
#define PCI_CS_INTERRUPT_LINE    0x3C
#define PCI_CS_INTERRUPT_PIN     0x3D
#define PCI_CS_MIN_GNT           0x3E
#define PCI_CS_MIN_LAT           0x3F

int get_base_addresses(BC_WORD, BC_WORD, int, int);
int pci_bios_present(BC_BYTE *, BC_WORD *, BC_BYTE *);
int pci_find_device(BC_WORD, BC_WORD, BC_WORD, BC_BYTE *, BC_BYTE *);
BC_DWORD pci_read_cs32(BC_BYTE, BC_BYTE, BC_WORD);
BC_BYTE pci_read_cs8(BC_BYTE, BC_BYTE, BC_WORD);
int pci_write_cs32(BC_BYTE, BC_BYTE, BC_WORD, BC_DWORD);
BC_DWORD in32(BC_DWORD);
int out32(BC_DWORD, BC_DWORD);
